#ifndef CONSTANTS_H_
#define CONSTANTS_H_

#include"config.h"
#include"interface.h"
#include"multiple.hpp"
//#include"microarray.hpp"
#include<string.h>
#include<stdlib.h>
#include<string>
#include<sstream>
#include<deque>
#include<stdio.h>
#include<boost/foreach.hpp>

#define foreach BOOST_FOREACH
#define rforeach BOOST_REVERSE_FOREACH


namespace allinone {

  struct charptr_less{
    bool operator() (const char * const & _1, const char * const &  _2) {
      return strcmp(_1, _2) < 0;
    }
  };
  
  template<class T, int reverse, class outit>
  class Iterator{
    public:
    T v;
    __INLINE Iterator(const T & v){
        this->v = v;
    }
    __INLINE T * operator-> () {return &v;}
    __INLINE T & operator * () {return v;}
  
    __INLINE bool operator == (const Iterator<T, reverse, outit> & vi) {
      return this->v == vi.v;
    }
  
    __INLINE bool operator != (const Iterator<T, reverse, outit> & vi) {
      return **this != vi.v;
    }

    __INLINE outit&operator ++ () { return *(outit *)this += 1; }
    __INLINE outit&operator -- () { return *(outit *)this -= 1; }
    __INLINE outit operator ++ (int unused) 
              { outit v = *((outit*)this); ++*this; return v; }
    __INLINE outit operator -- (int unused)
              { outit v = *((outit*)this); --*this; return v; }
  
    __INLINE outit operator + (int add) {outit v = *(outit *) this; return v+=add;}

    __INLINE outit operator - (int sub) {outit v = *(outit *) this; return v-=sub;}

    __INLINE outit&operator-= (int sub) {return *(outit *)this += -sub;}
    __INLINE outit&operator+= (int add) {return *(outit *)this += add;}
  };

  using namespace std;
  
  __INLINE
  list<string> * split(const string & str, const char delimit){
    if(str == "") return 0;
    size_t lastpos = 0, currpos = 0;
    list<string> * l = new list<string>(); 
    while(lastpos != string::npos){
//      LOG(DEBUG, "%ld:%ld", lastpos, currpos);
      currpos = str.find(delimit, lastpos);
      l->push_back(str.substr(lastpos, currpos - lastpos));
      if(currpos != string::npos) ++currpos;
      lastpos = currpos;
    }
    return l;
  }

  __INLINE
  void stripNRep(string & str){
    size_t beg = str.find_first_not_of(" \n\t\r");
    size_t end = str.find_last_not_of(" \n\t\r");
    if(beg == string::npos) str = "";
    else if(beg != 0 || end != str.size() - 1)
      str = str.substr(beg, end - beg + 1);
  }

  __INLINE
  string & getWriteFilename(string & str){
    if(str != "" && str[0] != '/' && str != "-") 
      str.insert(0, outDir);
    return str;    
  }
    

  __INLINE
  bool toFloat(string & str, double * val = 0, bool strip = false){
    if(strip) stripNRep(str);      
    const char * from = str.c_str();
    char * to = 0;
    double d = strtod(from, &to);
    if(to == from || to != &from[strlen(from)]) return false;
    if (val) *val = d; 
    return true;
  }

  __INLINE
  bool toInt(string & str, long * val = 0, bool strip = false){
    if(strip) stripNRep(str);      
    const char * from = str.c_str();
    char * to = 0;
    long d = strtol(from, &to, 0);
    if(to == from || to != &from[strlen(from)]) return false;
    if (val) *val = d; 
    return true;
  }

  template<class T>
  __INLINE
  string toString(T t){
    ostringstream ss;
    ss << t;
    return ss.str();
  }


  __INLINE
  list<string> * splitNStrip(const string & str, const char delimit){
    list<string> * l = split(str, delimit); 
    if(!l) return l;
    foreach(string & str, *l){
      stripNRep(str);
    }
    return l;
  }
  
  __INLINE 
  void skipEmpty(deque<string> * deq, int & line, char delimit){
    list<string> * l;
    for(l = allinone::splitNStrip((*deq)[line], delimit); line < deq->size() 
          && (l->size() == 0 || l->size() == 1 && l->front() == "") ; 
             l = allinone::splitNStrip((*deq)[++line], delimit)) delete l;
    if(deq->size() <= line) 
      LOG(ERROR, "File ended unexpectedly");
    delete l; 
  }

  __INLINE 
  deque<string> * getStringsFromFile(const char * name){
    FILE *f;
    if(!strcmp(name, "-")) f = stdin;
    else f = fopen(name, "r");
    if(!f) return 0;
    
    deque<string> * v = new deque<string>();
    int nextLine = 1;
    
    char line[1000] = {0};

    while(fgets(line, sizeof(line), f)){
      int len = strlen(line);
      if(nextLine) v->push_back(string(line));
      else         v->back() += string(line);
      if(line[len - 1] == '\n') nextLine = 1;
      else nextLine = 0;
    }
    return v;
  }
  
  __INLINE
  void freeFreeable(list<Interface *> l){
    foreach(Interface *i, l){
// "TODO not working, need to work this out"
//      if(i->freeAble) delete (Microarray<_PFloat> *)i;
    }
  }


  __INLINE
  char parseDelimiter(const string & str){
    if(str.size() == 1) return str[0];
    if(str.size() == 2 && str[0] == '\\'){
      switch(str[1]){
        case 't': return '\t';
        case 'n': return '\n';
        case 'r': return '\r';
        case ' ': return ' ';
      }
    }
    else LOG(ERROR, "Wrong delimiter: %s", str.c_str());
    return 0;
  }


template<class container>
  __INLINE
  void getInterfaces(container * cont, allinone::ArgAtom * aa, 
        InterfaceFlow::InterfaceArg desiredType = InterfaceFlow::All)
  {
    Multiple * mult = 0;
    Interface * interface;
    Package *p;
    switch(aa->argAtomType){
    case ArgAtom::ToProcess:
      if(aa->packages.size() > 1 && desiredType & InterfaceFlow::Multiple)
  cont->push_back((typename container::value_type)(mult = new Multiple()));
      for(Packages::iterator it2 = aa->packages.begin(); 
                             it2!= aa->packages.end(); ++it2){
        packageInterface.find((*it2)->name)->second(*it2);
        interface = (*it2)->interface; 
        if(interface->arg & desiredType || mult){
          if(mult) mult->interfaces.push_back(interface);
          else cont->push_back((typename container::value_type)interface);
        }else{
          LOG(ERROR, "The output of the package %s is not expected", 
                    (*it2)->name.c_str());
        }
      } break;
    case ArgAtom::PackageNumber:
      p = packagesByNumbers[atoi(aa->value.c_str())];
      packageInterface.find(p->name)->second(p);
      interface = p->interface;
      if(interface->arg & desiredType){
        cont->push_back((typename container::value_type)interface);
      }else{
        LOG(ERROR, "The output of the package %s is not expected", p->name.c_str());
      } break;
    default:
      LOG(ERROR, "Unsupported type: %d by the type", desiredType);
    }
  }

}


#endif /* CONSTANTS_H_ */
