#include<config.h>
#include<interface.h>
#include<constants.h>
#include"timer/timer.h"
#include<stdio.h>
#include<unistd.h>
#include<set>
#include<map>
#include<list>
#include<algorithm>

namespace multiple{

  using allinone::ArgAtoms;
  using allinone::ArgAtom;
  using allinone::Packages;
  using allinone::Package;
  using allinone::Multiple;
 
  InterfaceFunction{

    if(package->interface && package->interface->arg != InterfaceFlow::None)
      return 0;
    int n = 1;
    char str[100];
    sprintf(str, "%s:p[%d]", package->name.c_str(), package->packageNumber);
    timer::Timer t(str);
    t.start();
      Multiple * m = new Multiple();

      for(ArgAtoms::iterator it = package->argNode.begin(); 
            it != package->argNode.end(); ++it){
        if((*it)->argAtomType & (ArgAtom::LongSwitch | ArgAtom::ShortSwitch)){
          if((*it)->value == "-i" || (*it)->value == "--input"){
            *++it;
            switch((*it)->argAtomType){
            case ArgAtom::ToProcess:
            case ArgAtom::PackageNumber:
              getInterfaces(&m->interfaces, (*it), InterfaceFlow::All);
              break;
           case ArgAtom::Arg:
              LOG(WARNING, "The package limit doesn't read files; Wrong argument: %s", 
                    package->name.c_str());
            break;
            }
          }else if((*it)->value == "-o" || (*it)->value == "--output"){
            LOG(ERROR, "The %s package does not support ouputs.", package->name.c_str());
          }else if((*it)->value == "-n" || (*it)->value == "--number-of"){
            n = atoi((*++it)->value.c_str());
            if((n != 1)){
              LOG(ERROR, "Wrong argument of \"--number-of\" switch: %d", 
                        (*it)->value.c_str());
            }
          }
        }
      }

      package->interface = m;
      package->interface->readOnly=true;
      package->interface->freeAble = false;

    t.stop();
    return 0;
  }
}
