#ifndef PPI_INTERFACE_H_
#define PPI_INTERFACE_H_
  
#include<boost/preprocessor.hpp>
#include<interface.h>
#include<graph/interface.h>

  //SHOULD BE ALREADY INCLUDED
  //#include <interface.h>
  const ArgsDef args_ppi[] = { 
      {'d', "", arg_req_arg, "input/output file delimiter; default: '\\t'" },
      {'t', "data-type", arg_req_arg, "data type of the graph weights;"
        " Possible values are:\n\t\t" 
        STRINGIFY(BOOST_PP_SEQ_HEAD(DATATYPES))
        BOOST_PP_SEQ_FOR_EACH_I(DATATYPES_TOSTR, ", ", BOOST_PP_SEQ_TAIL(DATATYPES)) 
"\n\t\tThe default is [pfloat] and depending, on the compilation it is float or double.",
        STRINGIFY(BOOST_PP_SEQ_HEAD(DATATYPES))
        BOOST_PP_SEQ_FOR_EACH_I(DATATYPES_TOSTR, "|", BOOST_PP_SEQ_TAIL(DATATYPES)) 
      },
      {'g', "graph-type", arg_req_arg, "graph representation type; Possible values are:"
"\n\t\tmatrix (self implemented), adjacency_list, adjacency_matrix (boost)" 
"\n\t\tThe default is [matrix]. In general, matrix-based graphs are better"
"\n\t\tfor dense graphs and adjacency_list is better for sparse graphs.",
      "matrix|adjacency_list|adjacency_matrix"
      },
      {0, "", arg_no_arg, 
      "The package handling reading/writing the ppi network and representing it as a graph;\n"
      "The file should contain lines <gene name><delimiter><connection type><delimiter><gene name>\n"
      "It is standard SIF PPI network format."}};

  namespace ppi{

    InterfaceFunction;

    const InterfaceFlow interfaceFlow(
      InterfaceFlow::Graph, 
      InterfaceFlow::Graph);
  }



#endif /*PPI_INTERFACE_H_*/
